/*
Si vuole scrivere un programma C per la gestione delle informazioni per il  rinnovo delle patenti .
Il programma deve prevedere due strutture dati. Una per le persone che devono richiedere il rinnovo e l'altra per registrare l'esecuzione del rinnovo. 
Le persone sono caratterizzate dai seguenti dati: codice fiscale, data di nascita (aaaa/mm/gg),  tipo di patente ( 0= A, 1=B, 2=C, 3=D, 4=F), tipo di persona ( 0= persone con et < 50, 1 = persone con 50 <et <= 70, 2= persone con et > 70).  
Le registrazioni sono caratterizzate dai seguenti dati:  codice fiscale, data rinnovo (aaaa/mm/gg),  tipo di patente ( 0= A, 1=B, 2=C, 3=D, 4=F).
Le persone sono inserite in un vettore di 3 code, una per ogni tipo di persona. 
Le registrazioni sono inserite in un vettore di 5 liste, una per ogni tipo di patente.
Scrivere un programma C che codifichi  la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1)	Inserimento in coda di una persona 
2)	Visualizzazione delle persone presenti in una delle 3 code che richiedono il rinnovo per un tipo di patente. ( chiedere tramite tastiera il tipo di patente).
3)	Inserimento di una registrazione nel vettore di liste. 
4)	Eliminazione di una registrazione dal vettore di liste ( Chiedere da tastiera il tipo di patente e il codice fiscale).
5)	Salvataggio su file delle registrazioni 
6)	Lettura da file, visualizzazione sullo schermo  e inserimento delle registrazioni nel vettore di liste

Liberare la memoria allocata dinamicamente al termine dell'esecuzione

Non usare variabili globali


*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct{
    char codicef[17];
    char data[12];
    int tipo_patente;
    int tipo_persona;
}persona;

struct atomocoda{
    persona dato;
    struct atomocoda *suc;
};

struct coda{
    struct atomocoda *primo, *ultimo;
    };

typedef struct{
    char codicef[17];
    char data[12];
    int tipo_patente;
}registrazione;


struct atomo{
    registrazione dato;
    struct atomo *next;
};
    

void leggi_per(persona *p);
void in_coda(struct coda Q[3],persona p);
void vis_coda( struct coda Q[3]);
void leggi_reg(registrazione *r);
void ins_reg(struct atomo **rl,registrazione r);
void elimina_reg(struct atomo *L[5]);
void salva_lista( struct atomo*L[5]);
void carica_lista( struct atomo*L[5]);
void da_lista(struct atomo **rl);

main(){
    persona p;
    registrazione r;
    struct atomocoda *ac;
    int i,scelta;
    struct atomo *L[5],*al;
    struct coda Q[3];
    
    /*inizializza*/
    
    for(i=0;i<3;i++)
    {
        Q[i].primo=NULL;
        Q[i].ultimo=NULL;
    }
    
    for(i=0;i<5;i++)
       L[i]=NULL;
    
    do {
        printf("\nProgramma rinnovo patenti\n");
        printf("\nMENU'\n");
        printf("1-Ins.in coda\n2-Vis.coda\n");
        printf("3-Ins.registrazione\n4-Elimina. registrazione\n");
        printf("5-Salva reg\n6-Carica reg\n0-Chiudi il programma\n");
        scanf("%d",&scelta);
        switch (scelta){
            case 1:
                leggi_per(&p);
                i=p.tipo_persona;
                in_coda(Q,p);
                break;
            case 2:
                vis_coda(Q);
                break;
            case 3:
                 leggi_reg(&r);
                 i=r.tipo_patente;
                 ins_reg(&L[i],r);
                 break;
            case 4:
                 elimina_reg(L);
                 break;
            case 5:
                 salva_lista(L);
                 break;
            case 6:
                 carica_lista(L);
                 break;
            default:;
            }
    } while(scelta!=0);
            /*libera memoria*/
           
     for(i=0;i<3;i++)
        while(Q[i].primo!=NULL)
            {
                ac=Q[i].primo;
                Q[i].primo=ac->suc;
                free(ac);
            }
          
      for(i=0;i<5;i++)          
         while(L[i]!=NULL)
           da_lista(&L[i]);
            
}


void da_lista(struct atomo **rl)
{
    struct atomo *a;
    a=*rl;
    *rl=a->next;
    free(a);
}            
void leggi_per(persona *p)
{
    printf("Codice fiscale ");
    scanf("%s",p->codicef);
    printf("Data nascita ");
    scanf("%s",p->data);
    printf("Tipo patente(0=A,1=B,2=C,3=D,4=F) ");
    scanf("%d",&p->tipo_patente);
    printf("Tipo persona(0= fino a 50 anni,1= da 50 a 70 anni,2= anni >  70 ): ");
    scanf("%d",&p->tipo_persona);
}
    
void in_coda(struct coda Q[3],persona p)
{    
    int i;
    struct atomocoda *a;
    
    a=(struct atomocoda*)malloc(sizeof(struct atomocoda));
    if(a==NULL)
    return;
    
    i=p.tipo_persona;
    a->dato=p;
    a->suc=NULL;
    
    if(Q[i].primo==NULL)
        Q[i].primo=a;
    else Q[i].ultimo->suc=a;
    
    Q[i].ultimo=a;
}
void vis_coda( struct coda Q[3])
{
    struct atomocoda *a;
    int tipo;
    
    printf("Tipo persona(0= fino a 50 anni,1= da 50 a 70 anni,2= anni >  70 ): ");
    scanf("%d",&tipo);
    
    a = Q[tipo].primo;
    
    while(a!=NULL){
        printf("Codice fiscale: %s\n",a->dato.codicef);
        printf("Data di nascita (aaaa/mm/gg): %s\n",a->dato.data);
        a=a->suc;
        }
}
void leggi_reg(registrazione *r)
{
    printf("Codice fiscale");
    scanf("%s",r->codicef);
    printf("Data rinnovo");
    scanf("%s",r->data);
    printf("Tipo patente");
    scanf("%d",&r->tipo_patente);
}

void ins_reg(struct atomo **rl,registrazione r)
{
    struct atomo *a;
    a=(struct atomo *)malloc(sizeof(struct atomo));
    if(a==NULL)
    return;
    
    a->dato=r;
    a->next=*rl;
    *rl=a;
}
void elimina_reg(struct atomo *L[5])
{
    int k;
    char codicef[18];
    struct atomo *l1,*l2;
    printf("Tipo patente");
    scanf("%d",&k);
       
    if(L[k]==NULL)
      {
        printf("lista vuota\n");
        return;
      }
   
    printf("Codice fiscale");
    scanf("%s",codicef);   
      
    if(strcmp(codicef,L[k]->dato.codicef)==0) 
    /* trovato in testa */
        {
            da_lista(&L[k]);
            return;
        }
            
    l1=L[k]->next;
    l2=L[k];
    while(l1!=NULL)
        if(strcmp(codicef,l1->dato.codicef)==0)
            {
                l2->next=l1->next;
                free(l1);
                return;
            }
        else
                {
                 l2=l2->next;
                 l1=l1->next;
                 } 
    /* si arriva in questo punto solo se non e' stato trovato*/            
    printf("\nNon trovato\n");
}
        
void salva_lista( struct atomo*L[5])
{
    
    FILE *pf;
    struct atomo *a;
    registrazione r;
    int i;
    
    pf=fopen("registrazioni.txt","w");
    if(pf)
    {
        for(i=0;i<5;i++)
        {
            a=L[i];
            while(a!=NULL)
            {
                r=a->dato;
                fwrite(&r,sizeof(registrazione),1,pf);
                a=a->next;
            }
        }
       fclose(pf);     
    }
}

void carica_lista( struct atomo*L[5])
{
    FILE *pf;
    registrazione r;
    int i;
    
    pf=fopen("registrazioni.txt","r");
    if(pf){
        while(fread(&r,sizeof(registrazione),1,pf)!=0)
        {
            printf("Codice fiscale: %s\n",r.codicef);
            printf("Data di nascita (aaaa/mm/gg): %s\n\n",r.data);
            i=r.tipo_patente;
            ins_reg(&L[i],r);
        }
        fclose(pf);
        }
}

